# Expressions

### What's on this page:

[What is a Request ID?](#what-is-request-id)  
[Request IDs and rules for writing them](#request-id-rules)  
[Three types of logic rules with DEL](#three-types-logic)  

### Introduction to Dialob Expression Language

**Dialob Composer** comes with its own Domain Specific Language (DSL): Dialob Expression Language, or **DEL**. DEL has been designed to powerfully yet simply define the control logic of online forms. DEL is continuously enhanced and improved with new features to cover more complex cases and extend its usability to new areas.

### What is a Request ID? {#what-is-request-id}

The main variable used in DEL is a special meta variable called **Request**. Request is the meta variable used to gather (form user) input defined as **Response**.

A Request consists of two parts:

* **Request type**: Defines how user input is gathered. For example, a Text type will gather responses by the user in the form of text and return a String, whereas Integer type will gather numbers and return an Integer.

* **Request meta data**: Contains a hint/rubric/question describing what it wants the form user to do. Examples of a request include prompts such as "What is your name?" Take a picture” or “Select from the list”.  This can be thought of as the question prompt for the user to answer.

DEL also allows the defining of variables without binding to a Request, for example, [context variables](https://docs.dialob.io/dialob-variables/), and it also permits the creation of new types of variables.

### Request IDs and rules for writing them {#request-id-rules}

Request IDs (unique variable names) are automatically generated by Dialob Composer to speed up the dialog development process and to ensure that each Request has a unique ID by default. The user can change them as desired, and user-defined Request IDs uniqueness is automatically checked in near real time. Dialob Composer’s built-in ID notation check is based on the following naming conventions:

* The request ID must start with letter [a-z,A-Z]

* It can be followed by a number [0-9]

* It cannot be any reserved name (logical operators, comparison operators etc.)

* It must be unique. This is automatically checked by Dialob.

* Request IDs are case-sensitive. E.g. _firstname_ is not the same as _Firstname_.

* All of the changes to existing Request IDs are automatically updated by Dialob Composer and ensures that the previously-created control logic with DEL remains correct and up-to-date.

### Three types of logic rules with DEL {#three-types-logic}

DEL creates the logic to control the behavior of a dialog via three main control elements: **Visibility**, **Validation**, and **Required**.  Combined with Request IDs, DEL logic rules will determine the complexity of the end-user filling experience.

* **Visibility logic**: Defines if a given form element (unique request, group of requests or set of groups) is available in a given dialog when compared against a set of user inputs.  
In other words, visibility logic can be used to decide whether to show or to hide a certain question or group of questions based on a previous answer: E.g. If a user specifies that his/her age is 15, then visibility rules can be set to hide questions about spousal income, and these will not be asked.

* **Required logic**: Defines if a response (user interaction) is required for a given Request. The request must be visible.  
Required logic can be used in situations where, for example, a question about total household income can be required to be answered if a form user answers previously that he/she is married and both partners work.  

* **Validation logic**: Validates that the user response (user interaction) for a given Request is valid. The request must be visible.
The current state of Required and Validations is also "monitored" across all visible requests and the online rendering application (UI) is made "aware" if there are Required and / or Validation violations within a visible set of Requests.  
As a basic example, validation logic can be used to require a user to answer a question about his/her age with numbers only. If the user enters a short text or series of letters in the "age" field, the validation logic will catch this mistake and require the user to enter input in the specified correct format: Integer.  Validations are highly-customizable and can be written in a rich and complex manner.

<!--NOTE: There is ONLY one outcome of logic written on those elements: True. If not then Visibility, Required, Validations form control elements will do nothing and they do not exist in form context!-->
